/*******************************************************************
 * Xatm -- OCF, CID, TrueType scalable font support for X 
 *  By:  ͵ <y5t0964@students.chiba-u.ac.jp>
 */

/* $Id: metric.c,v 1.8 1999/09/29 20:08:14 elca Exp $ */

/* metric.c: ʸ礭׻ */

#include <math.h>
#include "metric.h"

/* ʲͼθ */
inline int xatm_d_to_i(double d)
{
	return (int)(d + 0.5);
}

inline double xatm_fmin(double a, double b)
{
	if(a < b) {
		return a;
	}
	return b;
}

inline double xatm_fmin4(double a, double b, double c, double d)
{
	return xatm_fmin(xatm_fmin(a, b), xatm_fmin(c, d));
}

inline double xatm_fmax(double a, double b)
{
	if(a > b) {
		return a;
	}
	return b;
}

inline double xatm_fmax4(double a, double b, double c, double d)
{
	return xatm_fmax(xatm_fmax(a, b), xatm_fmax(c, d));
}

/* ʸ */
inline double xatm_computeWidth(double matrix[4])
{
	return xatm_fmax4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2])
		- xatm_fmin4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2]);
}

/* ʸι⤵ */
inline double xatm_computeHeight(double matrix[4])
{
	return xatm_fmax4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3])
		- xatm_fmin4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3]);
}

/* ʸ */
inline double xatm_computeChWidth(double matrix[4])
{
	return xatm_fmax(fabs(matrix[0]), fabs(matrix[2]));
}

/*  */
inline double xatm_computeChHeight(double matrix[4])
{
	return xatm_fmax(fabs(matrix[1]), fabs(matrix[3]));
}


/* ʸκѤȺɸ (0,0) ȤΤ */
inline double xatm_computeXdelta(double matrix[4])
{
	return fabs(xatm_fmin4(0.0, matrix[0], matrix[2], matrix[0]+matrix[2]));
}

/* ʸκѤȺɸ (0,0) ȤΤ */
inline double xatm_computeYdelta(double matrix[4])
{
	return fabs(xatm_fmin4(0.0, matrix[1], matrix[3], matrix[1]+matrix[3]));
}

/* end */
